from .exception import EXCEPTION as EXCEPTION
from _typeshed import Incomplete
from abc import ABC
from typing import Any, Final, Sequence

class TypeSafeGetter:
    __RETURN_NONE_FOR_KEY_ERROR: Final[str]
    @classmethod
    def contains(cls, key: Any) -> bool: ...
    @classmethod
    def get_by_keys(cls, _dict: dict, _keys: Sequence, _default: Any | None = None, _deepcopy: bool = True) -> Any: ...
    @classmethod
    def keys(cls) -> tuple: ...
    @classmethod
    def _get_data(cls) -> dict: ...
    @classmethod
    def get(cls, *_key: Any, _deepcopy: bool = True) -> Any: ...
    @classmethod
    def try_get(cls, *_key: Any, _default: Any | None = None, _deepcopy: bool = True) -> Any | None: ...
    @classmethod
    def exists_not_none(cls, *_key: Any) -> bool: ...
    @classmethod
    def get_str(cls, *_key: Any) -> str: ...
    @classmethod
    def try_get_str(cls, *_key: Any) -> str | None: ...
    @classmethod
    def get_int(cls, *_key: Any) -> int: ...
    @classmethod
    def try_get_int(cls, *_key: Any) -> int | None: ...
    @classmethod
    def get_bool(cls, *_key: Any) -> bool: ...
    @classmethod
    def try_get_bool(cls, *_key: Any) -> bool | None: ...
    @classmethod
    def get_dict(cls, *_key: Any) -> dict: ...
    @classmethod
    def get_dict_ref(cls, *_key: Any) -> dict: ...
    @classmethod
    def try_get_dict(cls, *_key: Any) -> dict | None: ...
    @classmethod
    def get_list(cls, *_key: Any) -> list: ...
    @classmethod
    def try_get_list(cls, *_key: Any) -> list | None: ...
    @classmethod
    def get_tuple(cls, *_key: Any) -> tuple: ...
    @classmethod
    def try_get_tuple(cls, *_key: Any) -> tuple | None: ...

class TypeSafeSetter:
    @staticmethod
    def set_by_keys(_dict: dict, _keys: Sequence, value: object, assumeKeyExists: bool = True) -> None: ...
    @classmethod
    def _get_data(cls) -> dict: ...
    @classmethod
    def set(cls, *_key: str, value: Any, assumeKeyExists: bool = True) -> None: ...
    @classmethod
    def clear(cls) -> None: ...

class Hidable(ABC):
    __hidden: Incomplete
    def __init__(self, visible: bool = True) -> None: ...
    def set_visible(self, visible: bool) -> None: ...
    def is_visible(self) -> bool: ...
    def is_hidden(self) -> bool: ...
